use crate::prelude::*;
use library_loader::load_function_ptrs;

use std::os::raw::c_char;

load_function_ptrs!(EntryFunctions, {
    vkCreateInstance(
        pCreateInfo: *const VkInstanceCreateInfo<'_>,
        pAllocator: *const VkAllocationCallbacks,
        pInstance: *mut VkInstance
    ) -> VkResult,

    vkEnumerateInstanceExtensionProperties(
        pLayerName: *const c_char,
        pPropertyCount: *mut u32,
        pProperties: *mut VkExtensionProperties
    ) -> VkResult,

    vkEnumerateInstanceLayerProperties(
        pPropertyCount: *mut u32,
        pProperties: *mut VkLayerProperties
    ) -> VkResult,
});

impl EntryFunctions {
    pub fn new(static_functions: &StaticFunctions) -> Self {
        EntryFunctions::load(|name| unsafe {
            static_functions.vkGetInstanceProcAddr(VkInstance::NULL_HANDLE, name.as_ptr())
                as *const std::ffi::c_void
        })
    }
}
