use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

pub type VkBufferDeviceAddressInfoKHR = VkBufferDeviceAddressInfo;
pub type VkBufferDeviceAddressInfoEXT = VkBufferDeviceAddressInfo;

#[repr(C)]
pub struct VkBufferDeviceAddressInfo {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub buffer: VkBuffer,
}

impl VkBufferDeviceAddressInfo {
    pub fn new(buffer: VkBuffer) -> Self {
        VkBufferDeviceAddressInfo {
            sType: VK_STRUCTURE_TYPE_BUFFER_DEVICE_ADDRESS_INFO,
            pNext: ptr::null(),
            buffer,
        }
    }
}
